package no.ubicollab.osgi;

import java.util.*;
import org.osgi.framework.*;

import no.ubicollab.osgi.service.collaboration.*;

public class Activator implements BundleActivator {
	
	private BundleContext context = null;
	private CollaborationImpl collaboration = null;
    
    public void start(BundleContext bc) throws BundleException {
    	try {
    		context = bc;
	        Properties properties = new Properties();
	        properties.put("Language", "English");
	        properties.put("SOAP.service.name", "collaborationService");
	        collaboration = new CollaborationImpl();
	        context.registerService(CollaborationService.class.getName(), collaboration, properties);
    	} catch (Exception e) {
    		throw new BundleException("Failed to start Collaboration Service", e);
    	}
    }
    
    public void stop(BundleContext bc) throws BundleException {
    	try {
    		context = null;
    	} catch (Exception e) {
    		throw new BundleException("Failed to stop Collaboration Service", e);
    	}
    }
    
}