package no.ubicollab.osgi;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import no.ubicollab.osgi.service.datastorage.DataStorageService;

public class DataStorageImpl implements DataStorageService {
	
	private String homeDir = System.getProperty("user.home") + "\\UbiDataStorage"; 
	
	public DataStorageImpl() {
		
	}

	public boolean storeData(String username, String appName, String fileName, byte[] data) {
		System.out.println("Storing data..");
		String filePath = homeDir + "\\" + username + "\\" + appName;
		System.out.println(filePath + "\\" + fileName);
		
		try {
			File file = new File(filePath);
			file.mkdirs();
			file = new File(filePath + "\\" + fileName);
			file.createNewFile();
			FileOutputStream output = new FileOutputStream(file);
			output.write(data);
			output.close();
		} catch (FileNotFoundException fnfe) {
			fnfe.printStackTrace();
			return false;
		} catch (IOException ioe) {
			ioe.printStackTrace();
			return false;
		} 		
		System.out.println("Data is successfully stored.");
		
		return true;
	}

	public boolean deleteData(String username, String appName, String fileName) {
		String filePath = homeDir + "\\" + username + "\\" + appName + "\\" + fileName;
		System.out.println("Deleting " + filePath);
		File file = new File(filePath);
		boolean deleted = file.delete();
		System.out.println("File was deleted succesfully: " + deleted);
		return deleted;
	}

	public byte[] retrieveData(String username, String appName, String fileName) throws FileNotFoundException {
		String filePath = homeDir + "\\" + username + "\\" + appName + "\\" + fileName;
		FileInputStream input = new FileInputStream(filePath);
		byte[] data = null;
		try {
			int byteCount = input.available();
			data = new byte[byteCount];
			input.read(data);
			input.close();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
		
		return data;
	}

	public String[] listFileNames(String username, String appName) {
		String filePath = homeDir + "\\" + username + "\\" + appName;
		File dir = new File(filePath);
		String[] fileList = dir.list();
		
		return fileList;
	}
	
	public String[] listAppNames(String username) {
		String filePath = homeDir + "\\" + username;
		File dir = new File(filePath);
		String[] dirList = dir.list();
		
		return dirList;
	}
	
	
}