package no.ubicollab.osgi;

import java.util.*;
import org.osgi.framework.*;

import no.ubicollab.osgi.service.discovery.*;

public class Activator implements BundleActivator {

	private BundleContext context = null;

	private DiscoveryImpl discovery = null;

	public void start(BundleContext bc) throws BundleException {
		try {
			context = bc;
			Properties properties = new Properties();
			properties.put("Language", "English");
			properties.put("SOAP.service.name", "discoveryService");
			discovery = new DiscoveryImpl();
			context.registerService(DiscoveryService.class.getName(),
					discovery, properties);
		} catch (Exception e) {
			throw new BundleException("Failed to start Discovery Service", e);
		}
	}

	public void stop(BundleContext bc) throws BundleException {
		try {
			ServiceRemovalThread.stopThread();
			discovery.disconnectFromDatabase();
			context = null;
		} catch (Exception e) {
			throw new BundleException("Failed to stop Discovery Service", e);
		}
	}

}