package no.ubicollab.osgi;

import java.util.*;
import org.osgi.framework.*;
import no.ubicollab.osgi.service.positioning.gps.*;
import no.ubicollab.osgi.service.pocketdiscovery.PocketDiscoveryService;

public class Activator implements BundleActivator {
	
	public static BundleContext bc=null;
    private GpsPositioningImpl gps;
    
    public void start(BundleContext context) {
    	Activator.bc=context;
    	
        Properties properties = new Properties();
        properties.put("Language", "English");
        properties.put("SOAP.service.name", "gpsPositioningService");
        
        
        //Check if a local pocketDiscoveryService exists
        ServiceReference reference = context.getServiceReference(PocketDiscoveryService.class.getName());
        if(reference!=null){
        	//Local pocket discovery service exists.
        	//Start GpsPositioningImpl registering it in this discovery service using a local osgi call
        	PocketDiscoveryService discoveryService = (PocketDiscoveryService)context.getService(reference);
        	gps=new GpsPositioningImpl(discoveryService, this);
        	context.ungetService(reference);
        }
        else{
        	//No local pocket discovery service exists
        	//Start GpsPositioningImpl registering it in an external discoveryservice using a webservice call.
        	//The url to the external discoveryserivce is retrieved from the configfile
        	gps=new GpsPositioningImpl(this);
        }
        
        context.registerService(PositioningPluginService.class.getName(), gps, properties);
    }
    
    public void stop(BundleContext context) {
        System.out.println("Stopping GpsPositioning service");
        if(gps!=null)
        	gps.stop();
    }
    
}
