package no.ubicollab.osgi;

import java.io.*;

public class ConfigFileManager {
	
	private String filepath;

	public ConfigFileManager()
	{
		filepath = "gpsPositioningConfig.txt";
	}

	public ConfigFileManager(String filepath)
	{
		this.filepath = filepath;
	}
	
	public boolean writeConfigFile(String ownerUsername, String gpsComPort, String discoveryServiceUrl){
		PrintWriter pw;
		try {
			pw = new PrintWriter(new BufferedWriter(new FileWriter(filepath)));
			pw.println(ownerUsername);
			pw.println(gpsComPort);
			pw.println(discoveryServiceUrl);
			pw.close();
			return true;
		} catch (IOException e) {
			e.printStackTrace();
			return false;
		}
	}
	public String[] readConfigFile()
	{
		try
		{
			BufferedReader br = new BufferedReader(new FileReader(filepath));
			String ownerUsername = br.readLine();
			String gpsComPort = br.readLine();
			String discoveryServiceUrl = br.readLine();
			br.close();
			return new String[] {ownerUsername, gpsComPort, discoveryServiceUrl};
		}
		catch (Exception e)
		{
			System.out.println("<GsmPositioning>Exception in ConfigFileManager " + e.getMessage());
			//e.printStackTrace();
			return null;
		}
	}
}
