package no.ubicollab.osgi;

import java.util.Calendar;

public class LocationData
{
	public String type;
	public String time;
	public String warning;
	public String latitude; //in the format ddmm.mmmm
	public String latDir; //N or S
	public String longitude; //in the format dddmm.mmmm
	public String longDir; //E or W
	public String altitude;
	public String date;
	public String zone;

	public LocationData()
	{
		//this.time = ""+Calendar.getInstance().getTimeInMillis();
		this.time=""+0;
	}

	public LocationData(String longitude, String latitude, String altitude){
		this.longitude=longitude;
		this.latitude=latitude;
		this.altitude=altitude;
		//commented out because the pda does not allow the call
		//this.time = ""+Calendar.getInstance().getTimeInMillis();
		this.time=""+0;
	}
	
	public double getLatAsDecimalDegrees(){
		double sum=0.0;
		try{
			if(latitude!=null){
				double deg = Double.parseDouble(latitude.substring(0,2));
				double min = Double.parseDouble(latitude.substring(2))/60;
				sum = deg+min;
				if("S".equals(latDir))
					sum=-sum;
			}
			return sum;
		}
		catch(Exception e){
			System.out.println("Error converting to decimal degrees "+e);
			return sum;
		}
	}
	public double getLongAsDecimalDegrees(){
		double sum=0.0;
		try{
			if(longitude!=null){
				double deg = Double.parseDouble(longitude.substring(0,3));
				double min = Double.parseDouble(longitude.substring(3))/60;
				sum = deg+min;
				if("W".equals(longDir))
					sum=-sum;
			}
			return sum;
		}
		catch(Exception e){
			System.out.println("Error converting to decimal degrees "+e);
			return sum;
		}
	}
}