package no.ubicollab.osgi;

import java.util.*;
import org.osgi.framework.*;

import no.ubicollab.osgi.service.positioning.gsm.*;
import no.ubicollab.osgi.service.pocketdiscovery.PocketDiscoveryService;

public class Activator implements BundleActivator {
	
	public static BundleContext bc=null;
    private GsmPositioningImpl gsm;
	
    public void start(BundleContext context) {
    	Activator.bc=context;
    	
        Properties properties = new Properties();
        properties.put("Language", "English");
        properties.put("SOAP.service.name", "gsmPositioningService");
        
        
        
        //Check if a local pocketDiscoveryService exists
        ServiceReference reference = context.getServiceReference(PocketDiscoveryService.class.getName());
        if(reference!=null){
        	//Local pocket discovery service exists.
        	//Start GsmPositioningImpl registering it in this discovery service using a local osgi call
        	PocketDiscoveryService discoveryService = (PocketDiscoveryService)context.getService(reference);
        	gsm=new GsmPositioningImpl(discoveryService, this);
        	context.ungetService(reference);
        }
        else{
        	//No local pocket discovery service exists
        	//Start GsmPositioningImpl registering it in an external discoveryservice using a webservice call.
        	//The url to the external discoveryserivce is retrieved from the configfile
        	gsm=new GsmPositioningImpl(this);
        }
        
        context.registerService(PositioningPluginService.class.getName(), gsm, properties);
    }
    
    public void stop(BundleContext context) {
        System.out.println("Stopping GsmPositioning service");
        if(gsm!=null)
        	gsm.stop();
    }
    
}
