package no.ubicollab.osgi.service.positioning.gsm;

/**
 * Interface for the GsmPositioning Service. The service retrieves positioning data from the GSM-network.<br>
 * The service acts at a plug-in to the positioning service. This makes it possible for the Positioning Service to compare the data from several sources and pick the most accurate one. 
 * For this reason clients should not contact this service directly. Contact the Positioning Service instead<br><br>
 * 
 * 
 * @author Andreas Brustad
 * @see no.ubicollab.osgi.service.positioning.PositioningService
 *
 */
public interface PositioningPluginService {
	
	/**
	 * Gets the position of a user
	 * @param username The username of the user to be located 
	 * @return a double[] of length 3. Where [0] = longitude, [1] = latitude, [2] = altitude, or null if the position of this user is not found.
	 */
	public double[] getPosition(String username);
	
}
