package no.ubicollab.osgi;

import java.util.*;
import org.osgi.framework.*;

import no.ubicollab.osgi.service.location.*;
import no.ubicollab.osgi.service.pocketdiscovery.PocketDiscoveryService;

public class Activator implements BundleActivator {
	
	public static BundleContext bc=null;
	private LocationImpl locationImpl;
    
    public void start(BundleContext context) {
    	Activator.bc=context;
    	
        Properties properties = new Properties();
        properties.put("Language", "English");
        properties.put("SOAP.service.name", "locationService");
        
        //Check if a local pocketDiscoveryService exists
        ServiceReference reference = context.getServiceReference(PocketDiscoveryService.class.getName());
        if(reference!=null){
        	//Local pocket discovery service exists.
        	//Start LocationImpl registering it in this discovery service using a local osgi call
        	PocketDiscoveryService discoveryService = (PocketDiscoveryService)context.getService(reference);
        	locationImpl =new LocationImpl(discoveryService, this);
        	context.ungetService(reference);
        }
        else{
        	//No local pocket discovery service exists
        	//Start LocationImpl registering it in an external discoveryservice using a webservice call.
        	//The url to the external discoveryserivce is retrieved from the configfile
        	locationImpl = new LocationImpl(this);
        }
        
        context.registerService(LocationService.class.getName(), locationImpl, properties);
    }
    
    public void stop(BundleContext context) {
        if(locationImpl!=null){
        	locationImpl.saveLocationListToFile();
        	locationImpl.stop();
        }
    }
    
}
