package no.ubicollab.osgi;

import java.awt.Polygon;
import java.io.Serializable;

public class Location implements Serializable {

	public Polygon area;
	private int altitude;
	private String name;
	
	public Location(String locationName, double longitudes[], double[] latitudes, int altitude){
		name=locationName;
		this.altitude=altitude;
		if(longitudes.length!=latitudes.length)
			return;
		area=new Polygon();
		for(int i=0; i<longitudes.length; i++){
			int lon=(int)(longitudes[i]*1000000);
			int lat=(int)(latitudes[i]*1000000);
			area.addPoint(lon,lat);
		}
	}
	public boolean containsPoint(double longitude, double latitude){
		return area.contains((int)(longitude*1000000), (int)(latitude*1000000)); 
	}
	
	public boolean containsPoint(double longitude, double latitude, int altitude, int altitudeErrorMargin){
		boolean withinAlt = Math.abs(this.altitude-altitude)<=altitudeErrorMargin;
		return (withinAlt && area.contains( (int)(longitude*1000000), (int)(latitude*1000000)));
	}
	
	public String getName(){
		return name;
	}
	
}
