package no.ubicollab.osgi;

import java.util.*;
import org.osgi.framework.*;
import org.osgi.util.tracker.ServiceTracker;
import no.ubicollab.osgi.service.pocketdiscovery.PocketDiscoveryService;

public class Activator implements BundleActivator {
	
	public static BundleContext bc=null;
	
	private MyServiceTrackerCustomizer customizer;
	private ServiceTracker tracker;
    
    public void start(BundleContext context) {
    	Activator.bc=context;
    	
        Properties properties = new Properties();
        properties.put("Language", "English");
        properties.put("SOAP.service.name", "positioningService");
        
        customizer = new MyServiceTrackerCustomizer(context,properties);  
        tracker = new ServiceTracker(context, PocketDiscoveryService.class.getName(), customizer);  
        tracker.open();
    }
    
    //Called when this bundle is stopped by the framework.
    //Not to be confused with MyServiceTrackerCustomizer.removedService() which is called when the pocketDiscovery bundle is stopped
    public void stop(BundleContext context) {
        System.out.println("<PositioningService>Stopping Positioning service");
        customizer.stopThisService();
        Activator.bc=null;
        // Service is automatically unregistered
    }
    
}
