package no.ubicollab.osgi;

import java.util.Properties;

import no.ubicollab.osgi.service.pocketdiscovery.PocketDiscoveryService;
import no.ubicollab.osgi.service.positioning.PositioningService;

import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.util.tracker.ServiceTrackerCustomizer;

public class MyServiceTrackerCustomizer implements ServiceTrackerCustomizer {
	
	private BundleContext bc;
	private PositioningImpl posService;
	private Properties properties;
	
	public MyServiceTrackerCustomizer(BundleContext bc, Properties properties){
		this.bc=bc;
		this.properties=properties;
	}

	public Object addingService(ServiceReference reference) {
		System.out.println("<PositioningService>Detected pocketDiscovery. Starting...");
		PocketDiscoveryService pocketDiscovery = (PocketDiscoveryService)bc.getService(reference);
		posService = new PositioningImpl(pocketDiscovery);
		bc.registerService(PositioningService.class.getName(), posService, properties);
		return pocketDiscovery;
	}

	public void modifiedService(ServiceReference arg0, Object arg1) {
		System.out.println("<PositioningService>Detected modified pocketDiscovery. Doing nothing");

	}

	public void removedService(ServiceReference arg0, Object arg1) {
		System.out.println("<PositioningService>Detected stopped pocketDiscovery.");
		posService.pocketDiscoveryStopped();

	}
	public void stopThisService(){
		if(posService!=null)
			posService.stop();
	}

}
