package no.ubicollab.osgi;

import java.rmi.Remote;

/**
 * This interface is implemented by the proxy generated by the DynamicProxyGenerator class. 
 * Plugins do not need to implement this exact interface, but they have to implement a method with the same signarure as in this interface. 
 * @author Andreas Brustad
 * @see no.ubicollab.osgi.DynamicProxyGenerator
 */
public interface PositioningPluginService extends Remote {
	
	/**
	 * All plugins have to implement this method.
	 * @param username The username of the user to be located
	 * @return a double[] of length 3. Where [0] = longitude, [1] = latitude, [2] = altitude, or null if the position of this user is not found in this plugins.
	 */
	public double[] getPosition(String username);
	
}