package no.ubicollab.osgi;

import no.ubicollab.osgi.service.pocketdiscovery.PocketDiscoveryService;
import no.ubicollab.osgi.service.slideshow.SlideshowService;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.FileOutputStream;
import java.net.MalformedURLException;
import java.net.URL;

import javax.xml.rpc.ServiceException;

import no.ubicollab.axis.services.datastorageservice.*;

public class SlideshowImpl implements SlideshowService {

	private Robot robot;
	private no.ubicollab.axis.services.datastorageservice.DataStorageImpl dataStorageProxy = null;
	private File file;
	
	public SlideshowImpl(PocketDiscoveryService discoveryService) {
		String descriptionUrlAndProtocol = discoveryService.getService("type:no.ubicollab.osgi.service.datastorage");
		// TODO ** MUST BE ABLE TO GO THROUGH A SET OF DATA STORAGE SERVICES **
		if (!descriptionUrlAndProtocol.equals("No matching services") && !descriptionUrlAndProtocol.equals("Service stopped")) {
			String dataStorageServiceUrl = descriptionUrlAndProtocol.substring(0, descriptionUrlAndProtocol.indexOf(" "));
			DataStorageImplService dataStorageService = new DataStorageImplServiceLocator();
			try {
				dataStorageProxy = dataStorageService.getdataStorageService(new URL(dataStorageServiceUrl));
			} catch (ServiceException se) {
				se.printStackTrace();
			} catch (MalformedURLException mue) {
				mue.printStackTrace();
			}
		}
	}
	
	public void startSlideshow(String username, String appName, String fileName) {
		if (dataStorageProxy != null) {
			System.out.println(username + "/" + appName + "/" + fileName);
			try {
				robot = new Robot();
			} catch (AWTException awte) {
				awte.printStackTrace();
			}
			Runtime rt = Runtime.getRuntime();
			try {
				byte[] data = dataStorageProxy.retrieveData(username, appName, fileName);
				file = new File("slides.ppt");
				file.createNewFile();
				FileOutputStream output = new FileOutputStream(file);
				output.write(data);
				output.close();
				rt.exec("pptview /S \"" + System.getProperty("user.dir") + "\\slides.ppt\"");
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else {
			System.out.println("Slideshow could not be started, as no Data Storage service was found");
		}
	}
	
	public void stopSlideshow() {
		robot.keyPress(KeyEvent.VK_ESCAPE);
		try {
			file.delete();
		} catch (SecurityException se) {
			se.printStackTrace();
		}
	}
	
	public void nextSlide() {
		robot.keyPress(KeyEvent.VK_SPACE);
		robot.keyRelease(KeyEvent.VK_SPACE);
	}
	
	public void previousSlide() {
		robot.keyPress(KeyEvent.VK_BACK_SPACE);
		robot.keyRelease(KeyEvent.VK_BACK_SPACE);
	}
	
}
