using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PowerPointCtrl.WebReference;
using PowerPointCtrl.WebReference1;

namespace PowerPointCtrl
{
    public partial class Form1 : Form
    {
        private DiscoveryImplService discService;
        private SlideshowImplService slideShowService;
        public Form1()
        {
            InitializeComponent();
            discService = new DiscoveryImplService();
            slideShowService = new SlideshowImplService();
            FileAccess fileAccess = new FileAccess();
            string discoveryServiceUrl = fileAccess.ReadLineAndClose();
            if (discoveryServiceUrl != null)
                dsUrl.Text = discoveryServiceUrl;
        }

        public string GetDiscServiceUrl()
        {
            return dsUrl.Text;
        }

        private String[] searchForPPTServices()
	    {
		    try
		    {
			    discService.Url = dsUrl.Text;
			    //searchResult should have the format: url protocol url protocol.....
			    string searchResult = discService.getService("name:slideShowService");
			    if ("No matching services".Equals(searchResult) || "Error: Unknown service protocol".Equals(searchResult) || searchResult == null || searchResult.Length <= 0)
			    {
				    return new string[] { };
			    }
			    else
			    {
				    //Copy urls only
                    string[] urlAndProtocol = searchResult.Split(new Char [] {' '});
				    string[] urls = new string[urlAndProtocol.Length/2];
                    for(int i =0; i<urlAndProtocol.Length; i+=2)
                    {
				        urls[i/2]=urlAndProtocol[i];
				    }
				    return urls;
			    }
		    }
		    catch (Exception e)
            {
                MessageBox.Show("Could not search for ppt services");
                MessageBox.Show(e.Message);
                MessageBox.Show(e.StackTrace);
			    return new string[] { };
		    }
	}

        private void searchButton_Click(object sender, EventArgs e)
        {
            deviceList.DataSource = searchForPPTServices();
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            if (deviceList.SelectedItem != null)
            {
                slideShowService.Url = (string)deviceList.SelectedItem;
                slideShowService.startSlideshow();
            }
        }

        private void nextButton_Click(object sender, EventArgs e)
        {
            if (deviceList.SelectedItem != null)
            {
                slideShowService.Url = (string)deviceList.SelectedItem;
                slideShowService.nextSlide();
            }
        }

        private void previousButton_Click(object sender, EventArgs e)
        {
            if (deviceList.SelectedItem != null)
            {
                slideShowService.Url = (string)deviceList.SelectedItem;
                slideShowService.previousSlide();
            }
        }
    }
}