using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PowerPointCtrl2.DiscoveryService;

namespace PowerPointCtrl2
{
    public partial class Form1 : Form
    {
        private PocketDiscoveryImplService discoveryService;
        
        public Form1()
        {
            InitializeComponent();
            discoveryService = new PocketDiscoveryImplService();
            //Do not read from file anymore allways defalult to http://127.0.0.1:8080/axis/services/pocketDiscoveryService
            /*
            FileAccess fileAccess = new FileAccess();
            string discoveryServiceUrl = fileAccess.ReadLineAndClose();
            if (discoveryServiceUrl != null)
                dsUrl.Text = discoveryServiceUrl;
            */
        }

        private String[] searchForPPTServices()
        {
            try
            {
                discoveryService.Url = dsUrl.Text;
                searchButton.Text="Searching...";
                searchButton.Enabled = false;
                //searchResult should have the format: url protocol url protocol.....
                string searchResult = discoveryService.getService("name:slideShowService");
                searchButton.Text="Search";
                searchButton.Enabled = true;
                if ("No matching services".Equals(searchResult) || "Error: Unknown service protocol".Equals(searchResult) || searchResult == null || searchResult.Length <= 0)
                {
                    return new string[] { };
                }
                else
                {
                    //Copy urls only
                    string[] urlAndProtocol = searchResult.Split(new Char[] { ' ' });
                    string[] urls = new string[urlAndProtocol.Length / 2];
                    for (int i = 0; i < urlAndProtocol.Length; i += 2)
                    {
                        urls[i / 2] = urlAndProtocol[i];
                    }
                    return urls;
                }
            }
            catch (Exception e)
            {
                MessageBox.Show("Could not search for ppt services");
                MessageBox.Show(e.Message);
                MessageBox.Show(e.StackTrace);
                searchButton.Text="Search";
                searchButton.Enabled = true;
                return new string[] { };
            }
        }

        private void searchButton_Click(object sender, EventArgs e)
        {
            availableServices.Items.Clear();
            synchronizedServices.Items.Clear();
            string[] services = searchForPPTServices();
            foreach (string service in services)
            {
                availableServices.Items.Add(service);
            }
        }

        private void moveRight_Click(object sender, EventArgs e)
        {
            string select = (string)availableServices.SelectedItem;
            if (select != null)
            {
                synchronizedServices.Items.Add(new SlideshowServiceWrapper(select));
                availableServices.Items.Remove(availableServices.SelectedItem);
            }
        }

        private void moveLeft_Click(object sender, EventArgs e)
        {
            SlideshowServiceWrapper select = (SlideshowServiceWrapper)synchronizedServices.SelectedItem;
            if(select!=null)
            {
                availableServices.Items.Add(select.ToString());
                synchronizedServices.Items.Remove(synchronizedServices.SelectedItem);
            }
        }

        private void nextButton_Click(object sender, EventArgs e)
        {
            foreach (SlideshowServiceWrapper service in synchronizedServices.Items)
            {
                service.NextSlide();
            }
        }

        private void previousButton_Click(object sender, EventArgs e)
        {
            foreach (SlideshowServiceWrapper service in synchronizedServices.Items)
            {
                service.PreviousSlide();
            }
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            foreach (SlideshowServiceWrapper service in synchronizedServices.Items)
            {
                service.StartSlideShow();
            }
        }

        private void stopButton_Click(object sender, EventArgs e)
        {
            foreach (SlideshowServiceWrapper service in synchronizedServices.Items)
            {
                service.StopSlideShow();
            }
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            string select = (string)availableServices.SelectedItem;
            if (select != null)
            {
                MessageBox.Show(select);
            }
        }

        private void menuItem2_Click(object sender, EventArgs e)
        {
            SlideshowServiceWrapper select = (SlideshowServiceWrapper)synchronizedServices.SelectedItem;
            if (select != null)
            {
                MessageBox.Show(select.ToString());
            }
        }

    }
}