using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace RegisterLocation
{
    class PositionData
    {
        private double[] position;

        public double[] Position
        {
            get { return position; }
            set { position = value; }
        }

        public PositionData(double[] data)
        {
            position = data;
        }

        public PositionData(String data)
        {
            try
            {
                if ("Illegal position".Equals(data))
                {
                    position = new double[0];
                }
                else
                {
                    string[] dataArr = data.Split(new char[] { ';' });
                    position = new double[3];
                    position[0] = Double.Parse(dataArr[0]);
                    position[1] = Double.Parse(dataArr[1]);
                    position[2] = Double.Parse(dataArr[2]);
                }
            }
            catch (Exception)
            {
                position = new double[0];
                MessageBox.Show("Unable to create PositionData object");
            }
        }


        public override string ToString()
        {
            if (position.Length >= 3)
                return position[0] + ";" + position[1] + ";" + position[2];
            else
                return "Illegal position";
        }
    }
}
