package no.ubicollab.osgi.discovery.upnp;

import org.osgi.framework.*;
import org.osgi.util.tracker.*;

import no.ubicollab.osgi.service.discovery.*;

public class Activator implements BundleActivator {
	
	private BundleContext context = null;
	private MyServiceTrackerCustomizer customizer;
	private ServiceTracker tracker;

	public void start(BundleContext bc) throws BundleException {
		try {
			context = bc;
			customizer = new MyServiceTrackerCustomizer(context);
			tracker = new ServiceTracker(context, DiscoveryService.class.getName(), customizer);
			tracker.open();
		} catch (Exception e) {
			throw new BundleException("Failed to start UPnP Discovery plugin", e);
		}
    }
    
    public void stop(BundleContext bc) throws BundleException {
    	try {
	    	tracker.close();
	    	/*UPnPDiscovery upnpDiscovery = customizer.getUPnPDiscovery();
	    	if (upnpDiscovery != null) {
	    		upnpDiscovery.shutDownControlPoint();
	    	}*/
	    	context = null;
    	} catch (Exception e) {
    		throw new BundleException("Failed to stop UPnP Discovery plugin", e);
    	}
    }

}
