package no.ubicollab.osgi.discovery.upnp;

import no.ubicollab.osgi.service.discovery.DiscoveryService;

import org.osgi.framework.*;
import org.osgi.util.tracker.*;

public class MyServiceTrackerCustomizer implements ServiceTrackerCustomizer {
	
	private BundleContext context;
	private UPnPDiscovery upnpDiscovery = null;
	
	public MyServiceTrackerCustomizer(BundleContext bc) {
		context = bc;
	}
	
	public UPnPDiscovery getUPnPDiscovery() {
		return upnpDiscovery;
	}
	
	public Object addingService(ServiceReference reference) {
		System.out.println("UPnP: Found Directory Service");
		DiscoveryService discovery = (DiscoveryService) context.getService(reference);
		upnpDiscovery = new UPnPDiscovery(discovery);
		upnpDiscovery.startDiscovery();
		return discovery;
	}
	
	public void modifiedService(ServiceReference reference, Object serviceObject) {
		System.out.println("Modifying service");
		DiscoveryService discovery = (DiscoveryService) context.getService(reference);
		upnpDiscovery = new UPnPDiscovery(discovery);
		upnpDiscovery.startDiscovery();
	}
	
	public void removedService(ServiceReference reference, Object serviceObject) {
		System.out.println("UPnP: Directory Service was removed");
		upnpDiscovery.stopDiscovery();
	}

}
