package no.ubicollab.osgi.discovery.upnp;

import com.siemens.upnp.controlpoint.*;

import no.ubicollab.osgi.service.discovery.*;

public class UPnPDiscovery implements UPnPEventListener {

	protected ControlPoint cp;
	protected DiscoveryService discovery;
	
	public UPnPDiscovery(DiscoveryService discovery) {
		this.discovery = discovery;
		cp = ControlPoint.getInstance();
	}
	
	public void shutDownControlPoint() {
		cp.shutDown();
	}
	
	public void startDiscovery() {
		cp.addUPnPEventListener(this);
	}
	
	public void stopDiscovery() {
		cp.removeUPnPEventListener(this);
	}
	
	public void newDeviceAnnounced(String uuid, String type, String descriptionURL) {
		System.out.println("UPnP: Trying to register service");
		discovery.registerService(descriptionURL);
    }
	
	public void deviceRemoved(String uuid) {
		System.out.println("UPnP: Trying to remove service");
		discovery.removeService("uuId:" + uuid);
    }
	
	public void newServiceAnnounced(String uuid, String type, String descriptionURL) {
    }
	
	public void serviceRemoved(String uuid, String type) {
    }
		
}
