import java.awt.Container;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;

import org.cybergarage.upnp.device.InvalidDescriptionException;

public class UbiLight extends JFrame implements WindowListener {

	private Container contentPane;
	private JLabel pic;
	private UbiLightDevice lightDevice;
	private X10Imp controller;
	
	private String comport=null;
	private String housecode=null;
	private String unitcode=null;
	
	public UbiLight(String comport, String housecode, String unitcode){
		super("UbiCollab Light Device");
		
		this.comport=comport;
		this.housecode=housecode;
		this.unitcode=unitcode;
		
		contentPane=getContentPane();
		
		pic = new JLabel();

		contentPane.add(pic);
		
		addWindowListener(this);
		
		try{
			lightDevice=new UbiLightDevice(this);
			lightDevice.start();
		}
		catch(InvalidDescriptionException ide){
			System.out.println("Invalid description file");
			System.exit(0);
		}
		
		controller=new X10Imp(comport);
		turnOff();
		
		pack();
		setVisible(true);
	}
	
	public UbiLight(){
		super("UbiCollab Light Device");
		
		contentPane=getContentPane();
		
		pic = new JLabel();

		contentPane.add(pic);
		
		addWindowListener(this);
		
		try{
			lightDevice=new UbiLightDevice(this);
			lightDevice.start();
		}
		catch(InvalidDescriptionException ide){
			System.out.println("Invalid description file");
			System.exit(0);
		}
		turnOff();
		
		pack();
		setVisible(true);
	}
	
	public void turnOn(){
		pic.setIcon(new ImageIcon("description/lampOn.gif"));
		if(controller!=null){
			controller.on(housecode,unitcode);
		}
	}
	
	public void turnOff(){
		pic.setIcon(new ImageIcon("description/lampOff.gif"));
		if(controller!=null){
			controller.off(housecode,unitcode);
		}
	}
	
	
	//WindowListener
	
	public void windowOpened(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}

	public void windowClosing(WindowEvent arg0) {
		lightDevice.stop();
		if(controller!=null)
			controller.close();

	}

	public void windowClosed(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}

	public void windowIconified(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}

	public void windowDeiconified(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}

	public void windowActivated(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}

	public void windowDeactivated(WindowEvent arg0) {
		// TODO Auto-generated method stub

	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if(args.length==3 && !"NONE".equalsIgnoreCase(args[0])){
			new UbiLight(args[0],args[1], args[2]);
		}
		else if(args.length>0 && "NONE".equalsIgnoreCase(args[0]))
			new UbiLight();
		else{
			System.out.println("Usage:");
			System.out.println("UbiLight <COMPORT|NONE> <HOUSECODE> <UNITCODE>");
			System.out.println("E.G. Virtual device only: java UbiLight NONE");
			System.out.println("OR X-10 device: java UbiLight COM1 F 1");
		}
	}

}
