
import java.io.IOException;
import com.jpeterson.x10.Transmitter;
import com.jpeterson.x10.event.AddressEvent;
import com.jpeterson.x10.event.OffEvent;
import com.jpeterson.x10.event.OnEvent;
import com.jpeterson.x10.event.X10Event;
import com.jpeterson.x10.Gateway;
import com.jpeterson.x10.GatewayException;
import com.jpeterson.x10.SerialGateway;

public class X10Imp{


private Transmitter transmitter;

public X10Imp(String port){
	try{
		transmitter = (Transmitter)Class.forName("com.jpeterson.x10.module.CM11A").newInstance();
	}
	catch (ClassNotFoundException e){
		System.err.println("Unknown class: com.jpeterson.x10.module.CM11A");
		e.printStackTrace();
		System.exit(1);
	}
	catch (InstantiationException e){
		System.err.println("Error instantiating com.jpeterson.x10.module.CM11A");
		e.printStackTrace();
		System.exit(1);
	}
	catch (IllegalAccessException e){
		System.err.println("Illegally accessing com.jpeterson.x10.module.CM11A");
		e.printStackTrace();
		System.exit(1);
	}

	Gateway gateway = (Gateway)transmitter;
	if ((transmitter instanceof SerialGateway) && (port != null)){
		((SerialGateway)transmitter).setPortName(port);
    }
	try{
		gateway.allocate();
	}
	catch (Exception e){
		e.printStackTrace();
	}
}

public void on(String huskode, String appkode){
	char hus =huskode.charAt(0);
	int app= Integer.parseInt(appkode);
	X10Event[] events = new X10Event[2];
	events[0] = new AddressEvent(this, hus, app);
    events[1] = new OnEvent(this, hus);
    for(int i=0; i<events.length; i++){
	    System.out.println("Sender: " + events[i]);
	    try{
	       transmitter.transmit(events[i]);
	    }
	    catch (IOException e){
	    	e.printStackTrace();
	    }
    }
}

public void off(String huskode, String appkode){
	char hus =huskode.charAt(0);
	int app= Integer.parseInt(appkode);
	X10Event[] events = new X10Event[2];
	events[0] = new AddressEvent(this, hus, app);
    events[1] = new OffEvent(this, hus);
    for(int i=0; i<events.length; i++){
	    System.out.println("Sender: " + events[i]);
	    try{
	       transmitter.transmit(events[i]);
	    }
	    catch (IOException e){
	    	e.printStackTrace();
	    }
    }
}

public void close(){
	Gateway gateway = (Gateway)transmitter;

	try{
		System.out.print("Venter p tom k...");
		gateway.waitGatewayState(Transmitter.QUEUE_EMPTY);
	    System.out.println("Ferdig");
	}
	catch (InterruptedException e){
	}

	System.out.print("Deallokerer...");
	try{
		gateway.deallocate();
	}
	catch (GatewayException e){
		e.printStackTrace();
	}
	System.out.println("Ferdig");
}

public static void main(String args[]){
	X10Imp x10= new X10Imp("COM2");
	x10.close();
}

}